=== src/eckit/CMakeLists.txt ===
### endianess

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
        set( eckit_BIG_ENDIAN    1 )
        set( eckit_LITTLE_ENDIAN 0 )
else()
        set( eckit_BIG_ENDIAN    0 )
        set( eckit_LITTLE_ENDIAN 1 )
endif()

set( ECKIT_BIG_ENDIAN    ${eckit_BIG_ENDIAN}    )
set( ECKIT_LITTLE_ENDIAN ${eckit_LITTLE_ENDIAN} )

### check support for DL library

check_include_files( dlfcn.h  eckit_HAVE_DLFCN_H )

if(NOT eckit_HAVE_DLFCN_H)
message(FATAL_ERROR "eckit requires dlfcn.h for supporting dlopen of shared libraries")
endif()

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        eckit_HAVE_DLADDR )
cmake_pop_check_state()

### system headers and symbols tests for eckit config headers

check_symbol_exists( MAP_ANONYMOUS   "sys/mman.h"  eckit_HAVE_MAP_ANONYMOUS )
check_symbol_exists( MAP_ANON        "sys/mman.h"  eckit_HAVE_MAP_ANON )
check_symbol_exists( funopen         "stdio.h"     eckit_HAVE_FUNOPEN )
check_symbol_exists( fsync           "unistd.h"    eckit_HAVE_FSYNC )
check_symbol_exists( fdatasync       "unistd.h"    eckit_HAVE_FDATASYNC )
check_symbol_exists( F_FULLFSYNC     "fcntl.h"     eckit_HAVE_F_FULLFSYNC )
check_symbol_exists( fmemopen        "stdio.h"     eckit_HAVE_FMEMOPEN )
check_symbol_exists( dlinfo          "dlfcn.h"     eckit_HAVE_DLINFO )
check_symbol_exists( feenableexcept  "fenv.h"      eckit_HAVE_FEENABLEEXCEPT )
check_symbol_exists( fedisableexcept "fenv.h"      eckit_HAVE_FEDISABLEEXCEPT )

check_c_source_compiles( "#define _GNU_SOURCE\n#include <stdio.h>\nint main(){ void* cookie; const char* mode; cookie_io_functions_t iof; FILE* fopencookie(void *cookie, const char *mode, cookie_io_functions_t iof); }"
    eckit_HAVE_FOPENCOOKIE )

check_c_source_compiles( "#include <unistd.h>\n#include <execinfo.h>\n int main(){ void ** buffer; int i = backtrace(buffer, 256); }\n"
    eckit_HAVE_EXECINFO_BACKTRACE )

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    eckit_HAVE_CXXABI_H )

check_c_source_compiles( "#include <time.h>\nint main(){ time_t now; time(&now); struct tm t; gmtime_r(&now,&t); }\n"
    eckit_HAVE_GMTIME_R )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; struct dirent **result; int i = readdir_r(dirp, entry, result); }\n"
    eckit_HAVE_READDIR_R )

check_c_source_compiles( "#include <sys/types.h>\n#include <dirent.h>\nint main(){ DIR *dirp; int i = dirfd(dirp); }\n"
    eckit_HAVE_DIRFD )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; if(entry->d_type) { dirp = 0; } }\n"
    eckit_HAVE_DIRENT_D_TYPE )

check_cxx_source_compiles( "int main() { __int128 i = 0; return 0;}"
    eckit_HAVE_CXX_INT_128 )

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_config.h.in   eckit_config.h  )
configure_file( eckit_version.h.in  eckit_version.h )

install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/eckit_config.h
        ${CMAKE_CURRENT_BINARY_DIR}/eckit_version.h
    DESTINATION
        ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_version.cc.in  eckit_version.cc )

### eckit sources

list( APPEND eckit_srcs eckit.h deprecated.h ${CMAKE_CURRENT_BINARY_DIR}/eckit_version.cc )

list( APPEND eckit_container_srcs
    container/BSPTree.h
    container/BTree.cc
    container/BTree.h
    container/BloomFilter.cc
    container/BloomFilter.h
    container/Cache.h
    container/CacheLRU.cc
    container/CacheLRU.h
    container/CacheManager.cc
    container/CacheManager.h
    container/ClassExtent.h
    container/DenseMap.h
    container/DenseSet.h
    container/KDMapped.cc
    container/KDMapped.h
    container/KDMemory.h
    container/KDTree.h
    container/MappedArray.cc
    container/MappedArray.h
    container/Queue.h
    container/Recycler.h
    container/SharedMemArray.cc
    container/SharedMemArray.h
    container/StatCollector.h
    container/Trie.cc
    container/Trie.h
    container/bsptree/BSPHyperPlane.h
    container/bsptree/BSPNode.cc
    container/bsptree/BSPNode.h
    container/kdtree/KDNode.cc
    container/kdtree/KDNode.h
    container/sptree/SPIterator.h
    container/sptree/SPMetadata.h
    container/sptree/SPNode.h
    container/sptree/SPNodeInfo.h
    container/sptree/SPNodeQueue.h
    container/sptree/SPTree.h
    container/sptree/SPValue.h
)

list( APPEND eckit_io_srcs
    io/AIOHandle.cc
    io/AIOHandle.h
    io/AsyncHandle.cc
    io/AsyncHandle.h
    io/AutoCloser.h
    io/Base64.cc
    io/Base64.h
    io/BitIO.cc
    io/BitIO.h
    io/Buffer.cc
    io/Buffer.h
    io/BufferCache.cc
    io/BufferCache.h
    io/BufferList.cc
    io/BufferList.h
    io/BufferedHandle.cc
    io/BufferedHandle.h
    io/CircularBuffer.cc
    io/CircularBuffer.h
    io/CommandStream.cc
    io/CommandStream.h
    io/Compress.cc
    io/Compress.h
    io/DataHandle.cc
    io/DataHandle.h
    io/DblBuffer.cc
    io/DblBuffer.h
    io/EmptyHandle.cc
    io/EmptyHandle.h
    io/FDataSync.cc
    io/FDataSync.h
    io/FOpenDataHandle.cc
    io/FTPHandle.cc
    io/FTPHandle.h
    io/FileBase.cc
    io/FileBase.h
    io/FileDescHandle.cc
    io/FileDescHandle.h
    io/FileHandle.cc
    io/FileHandle.h
    io/FileLock.cc
    io/FileLock.h
    io/FileLocker.cc
    io/FileLocker.h
    io/FilePool.cc
    io/FilePool.h
    io/HandleBuf.cc
    io/HandleBuf.h
    io/HandleHolder.cc
    io/HandleHolder.h
    io/Length.cc
    io/Length.h
    io/MMappedFileHandle.cc
    io/MMappedFileHandle.h
    io/MemoryHandle.cc
    io/MemoryHandle.h
    io/MoverTransfer.cc
    io/MoverTransfer.h
    io/MoverTransferSelection.cc
    io/MoverTransferSelection.h
    io/MultiHandle.cc
    io/MultiHandle.h
    io/MultiSocketHandle.cc
    io/MultiSocketHandle.h
    io/Offset.cc
    io/Offset.h
    io/PartFileHandle.cc
    io/PartFileHandle.h
    io/PartHandle.cc
    io/PartHandle.h
    io/PeekHandle.cc
    io/PeekHandle.h
    io/PipeHandle.cc
    io/PipeHandle.h
    io/Pipeline.cc
    io/Pipeline.h
    io/PooledFile.cc
    io/PooledFile.h
    io/PooledFileDescriptor.cc
    io/PooledFileDescriptor.h
    io/PooledHandle.cc
    io/PooledHandle.h
    io/RawFileHandle.cc
    io/RawFileHandle.h
    io/ResizableBuffer.h
    io/SeekableHandle.cc
    io/SeekableHandle.h
    io/Select.cc
    io/Select.h
    io/SharedBuffer.cc
    io/SharedBuffer.h
    io/SharedHandle.cc
    io/SharedHandle.h
    io/SockBuf.cc
    io/SockBuf.h
    io/StatsHandle.cc
    io/StatsHandle.h
    io/StdFile.cc
    io/StdFile.h
    io/StdPipe.cc
    io/StdPipe.h
    io/StdioBuf.cc
    io/StdioBuf.h
    io/TCPHandle.cc
    io/TCPHandle.h
    io/TCPSocketHandle.cc
    io/TCPSocketHandle.h
    io/TeeHandle.cc
    io/TeeHandle.h
    io/TransferWatcher.cc
    io/TransferWatcher.h
    io/cluster/ClusterDisks.cc
    io/cluster/ClusterDisks.h
    io/cluster/ClusterNode.cc
    io/cluster/ClusterNode.h
    io/cluster/ClusterNodes.cc
    io/cluster/ClusterNodes.h
    io/cluster/NodeInfo.cc
    io/cluster/NodeInfo.h
)

if(HAVE_CURL)
    list(APPEND eckit_io_srcs
        io/EasyCURL.cc
        io/EasyCURL.h
        io/URLHandle.cc
        io/URLHandle.h
    )
endif()

list(APPEND eckit_message_srcs
    message/Decoder.cc
    message/Decoder.h
    message/Message.cc
    message/Message.h
    message/MessageContent.cc
    message/MessageContent.h
    message/Reader.cc
    message/Reader.h
    message/Splitter.cc
    message/Splitter.h
)

if(HAVE_RADOS)
    list( APPEND eckit_io_srcs
        io/rados/RadosHandle.cc
        io/rados/RadosHandle.h
        io/rados/RadosCluster.h
        io/rados/RadosCluster.cc
        io/rados/RadosReadHandle.cc
        io/rados/RadosReadHandle.h
        io/rados/RadosWriteHandle.cc
        io/rados/RadosWriteHandle.h
        io/rados/RadosObject.h
        io/rados/RadosObject.cc
        io/rados/RadosAttributes.h
        io/rados/RadosAttributes.cc
    )
endif()

list( APPEND eckit_filesystem_srcs
    filesystem/BasePathName.cc
    filesystem/BasePathName.h
    filesystem/BasePathNameT.cc
    filesystem/BasePathNameT.h
    filesystem/FileMode.cc
    filesystem/FileMode.h
    filesystem/FileSpace.cc
    filesystem/FileSpace.h
    filesystem/FileSpaceStrategies.cc
    filesystem/FileSpaceStrategies.h
    filesystem/FileSystem.cc
    filesystem/FileSystem.h
    filesystem/FileSystemSize.h
    filesystem/LocalPathName.cc
    filesystem/LocalPathName.h
    filesystem/PathExpander.cc
    filesystem/PathExpander.h
    filesystem/PathName.cc
    filesystem/PathName.h
    filesystem/PathNameFactory.cc
    filesystem/PathNameFactory.h
    filesystem/TempFile.cc
    filesystem/TempFile.h
    filesystem/TmpDir.cc
    filesystem/TmpDir.h
    filesystem/StdDir.cc
    filesystem/StdDir.h
    filesystem/TmpFile.cc
    filesystem/TmpFile.h
    filesystem/URI.cc
    filesystem/URI.h
    filesystem/URIManager.cc
    filesystem/URIManager.h
    filesystem/LocalFileManager.cc
    filesystem/LocalFileManager.h
)

list( APPEND eckit_thread_srcs
    thread/AutoLock.h
    thread/Mutex.cc
    thread/Mutex.h
    thread/MutexCond.cc
    thread/MutexCond.h
    thread/Once.h
    thread/StaticMutex.cc
    thread/StaticMutex.h
    thread/Thread.cc
    thread/Thread.h
    thread/ThreadControler.cc
    thread/ThreadControler.h
    thread/ThreadPool.cc
    thread/ThreadPool.h
    thread/ThreadSingleton.h
)

list( APPEND eckit_config_srcs
    config/Configurable.cc
    config/Configurable.h
    config/Configuration.cc
    config/Configuration.h
    config/Configured.cc
    config/Configured.h
    config/EtcTable.cc
    config/EtcTable.h
    config/JSONConfiguration.h
    config/LibEcKit.cc
    config/LibEcKit.h
    config/LocalConfiguration.cc
    config/LocalConfiguration.h
    config/Parametrisation.cc
    config/Parametrisation.h
    config/Resource.h
    config/ResourceBase.cc
    config/ResourceBase.h
    config/ResourceMgr.cc
    config/ResourceMgr.h
    config/YAMLConfiguration.cc
    config/YAMLConfiguration.h
)

list( APPEND eckit_runtime_srcs
    runtime/Application.cc
    runtime/Application.h
    runtime/Dispatcher.h
    runtime/Library.cc
    runtime/Library.h
    runtime/Main.cc
    runtime/Main.h
    runtime/Metrics.cc
    runtime/Metrics.h
    runtime/Monitor.cc
    runtime/Monitor.h
    runtime/Monitorable.cc
    runtime/Monitorable.h
    runtime/Pipe.h
    runtime/PipeApplication.cc
    runtime/PipeApplication.h
    runtime/PipeHandler.cc
    runtime/PipeHandler.h
    runtime/ProcessControler.cc
    runtime/ProcessControler.h
    runtime/ProducerConsumer.h
    runtime/Telemetry.cc
    runtime/Telemetry.h
    runtime/SessionID.cc
    runtime/SessionID.h
    runtime/Task.cc
    runtime/Task.h
    runtime/TaskID.h
    runtime/TaskInfo.cc
    runtime/TaskInfo.h
    runtime/Tool.cc
    runtime/Tool.h
)

list( APPEND eckit_log_srcs
    log/BigNum.cc
    log/BigNum.h
    log/Bytes.cc
    log/Bytes.h
    log/CallbackTarget.cc
    log/CallbackTarget.h
    log/Channel.cc
    log/Channel.h
    log/ChannelBuffer.cc
    log/ChannelBuffer.h
    log/CodeLocation.cc
    log/CodeLocation.h
    log/Colour.cc
    log/Colour.h
    log/ColouringTarget.cc
    log/ColouringTarget.h
    log/ETA.cc
    log/ETA.h
    log/FileTarget.cc
    log/FileTarget.h
    log/IndentTarget.cc
    log/IndentTarget.h
    log/JSON.cc
    log/JSON.h
    log/LineBasedTarget.cc
    log/LineBasedTarget.h
    log/Log.cc
    log/Log.h
    log/LogTarget.cc
    log/LogTarget.h
    log/MessageTarget.cc
    log/MessageTarget.h
    log/MonitorTarget.cc
    log/MonitorTarget.h
    log/Number.cc
    log/Number.h
    log/OStreamTarget.cc
    log/OStreamTarget.h
    log/Plural.h
    log/PrefixTarget.cc
    log/PrefixTarget.h
    log/Progress.cc
    log/Progress.h
    log/ProgressTimer.cc
    log/ProgressTimer.h
    log/ResourceUsage.cc
