=== debian/changelog ===
eckit (2.0.1-2) unstable; urgency=medium

  * Disable HIP; missing on some archs

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Feb 2026 07:34:39 +0000

eckit (2.0.1-1) unstable; urgency=medium

  * New upstream release
  * Cleanup d/control with cme
  * Drop leading / in d/*install paths
  * Header for zip.patch
  * JEMALLOC support dropped in 2.0.0
  * Drop RSYNC dependencies; no longer used
  * Undo zip.patch; Debian now uses standard name

  * disable-cache-test.patch: Drop test that breaks compilation

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Feb 2026 09:30:52 +0000
