=== debian/control ===
Source: eckit
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Alastair McKinstry <mckinstry@debian.org>,
Section: science
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit,
 ecbuild,
 chrpath,
 flex,
 bison,
 libopenblas-dev [ !alpha !hurd-amd64 ],
 libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
 liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
 libaec-dev,
 libxxhash-dev,
 librados-dev [ !loong64 ],
 libradospp-dev,
 libproj-dev,
 libbz2-dev,
 liblz4-dev,
 libshp-dev,
 libzip-dev,
 libeigen3-dev,
 libsnappy-dev,
 libqhull-dev,
 mpi-default-dev,
 doxygen,
 sphinx-common,
 python3-sphinx,
 python3-pydata-sphinx-theme,
 python3-breathe,
 python3-sphinxcontrib.jquery,
 python3-all,
 libssl-dev,
 libcurl4-gnutls-dev,
 libncurses-dev,
 libhipsparse-dev [amd64 arm64 ppc64el],
Vcs-Browser: https://salsa.debian.org/science-team/eckit
Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest
Homepage: https://github.com/ecmwf/eckit

Package: libeckit-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libeckit0d (= ${binary:Version}),
 libeckit-utils (= ${binary:Version}),
 mpi-default-dev,
 libaec-dev,
 libssl-dev,
 libcurl4-gnutls-dev,
 libxxhash-dev,
 libsnappy-dev,
 liblz4-dev,
 libbz2-dev,
 libeigen3-dev,
 libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
 libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
 liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
 ${shlibs:Depends},
 ${misc:Depends},
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libeckit0d ( = ${binary:Version}),
 ${shlibs:Depends},
Recommends:
 libeckit-dev,
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
