=== debian/watch ===
# Avoid v5 for now; 200x.xx.xx tags get pulled
version=4
https://github.com/ecmwf/eckit/tags .*/v?(\d.*)@ARCHIVE_EXT@
